<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of ePUBmaker, a plugin for Dotclear 2.
# 
# Copyright (c) 2012 Osku and contributors
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------
#
if (!defined('DC_CONTEXT_ADMIN')) { return; }

$icon = 'index.php?pf=ePUBmaker/icon.png';

// superadmin or admin :
$permission = $core->auth->check('admin',$core->blog->id);

$_menu['Plugins']->addItem(__('ePUB maker'),
	'plugin.php?p=ePUBmaker',
	$icon,
	preg_match('/plugin.php\?p=ePUBmaker(.*)?$/',$_SERVER['REQUEST_URI']),
	$permission
);

$flag = $core->blog->settings->epubmaker->flag;

if ($flag) {
	if ($core->auth->check('contentadmin,usage',$core->blog->id)
	&& $core->auth->check('media,media_item',$core->blog->id)) {
		$core->addBehavior('adminPostsActionsPage',array('epubmakerBehaviors','adminPostsActionsPage'));
	}	
}

class epubmakerBehaviors
{
	public static function adminPostsActionsPage($core,$ap)
	{
		$ap->addAction(
			array(__('eBook') => array(__('Create ePUB') => 'epub') ),
			array('epubmakerBehaviors', 'doEpub')
		);
	}
	
	public static function doEpub($core, dcPostsActionsPage $ap, $post) {
		if ($post['action'] == 'epub' && isset($post['epub_filename'])&& isset($post['epub_title']) && isset($post['epub_subject']))
		{
			// Le formulaire intermédiaire a été soumis	
			ePUBtools::load();
			$core->ePUBmaker->createEPUB(
				$ap->getRS(),
				$post['epub_title'],
				$post['epub_subject'],
				$post['epub_filename'],
            $post['sortby'],
            $post['order']
			);
			ePUBtools::unload();

			//$ap->redirect(true,array('upd' => 1));
			$redir = 'media.php?popup=0&post_id=&d='.rawurlencode($core->blog->settings->epubmaker->repo);
			http::redirect($redir);
			
		} else {
			
			// On affiche le formulaire intermédiaire
			$ap->beginPage();			
			echo
			'<h2><span class="page-title">'.__('ePUB creation').'</span></h2>'.
			'<form action="'.$ap->getURI().'" method="post">'.
			// On affiche la sélection des billets pour être sûr
			$ap->getCheckboxes().
			
			'<p><label class="required" for="epub_filename"><abbr title="'.__('Required field').'">*</abbr> '.__('Filename:').' '.
			form::field('epub_filename',40,255).
			'</label></p> 
			<p class="form-note warn">'.__('File extension (<code>.epub</code>) is automatically added.').'</p>'.
			'<p><label for="epub_title">'.__('Title:').' '.
			form::field('epub_title',40,255).
			'</label></p> '.
			'<p class="form-note">'.__('Leave empty to use blog name').'</p>'.
			'<div class="p"><label class="area" for="epub_subject">'.__('Subject:').' </label>'.
			form::textarea('epub_subject',80,10,'','maximal').
			'</div> 
			<p class="form-note">'.__('Leave empty to use blog description').'</p>'.
			// On n'oublie pas les champs cachés, le nonce et l'action
			$ap->getHiddenFields().
			$core->formNonce().
			form::hidden(array('action'),'epub').
			form::hidden(array('sortby'),$_POST['sortby']).
			form::hidden(array('order'),$_POST['order']).
			'<p><input type="submit" value="'.__('Create').'" name="epub" /></p>'.
			'</form>';
			# Et on ferme...
			$ap->endPage();	
		}
	}
}
?>
